﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using EJ2Grid.Models;
using Syncfusion.EJ2.Base;
using System.Collections;
using Syncfusion.EJ2.QueryBuilder;
using EJ2Grid.Models;

namespace EJ2Grid.Controllers
{
    public class HomeController : Controller
    {
        public static List<OrdersDetails> orddata = new List<OrdersDetails>();
        public static List<Employees> Employee = new List<Employees>();
        public IActionResult Index()
        {
            if (orddata.Count == 0)
                BindData();
            if (Employee.Count == 0)
                BindEpmployeeDataSource();
            ViewBag.data = orddata;
            ViewBag.empData = Employee;
            ViewBag.BaseRecord = BaseTypes.GetAllBaseTypes();
            ViewBag.PurType = PurTypes.GetAllPurTypes();

            return View();
        }
        
        public IActionResult UrlDatasource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = orddata;
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<OrdersDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);         //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult QBDatasource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = orddata;
            DataOperations operation = new DataOperations();
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<OrdersDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);         //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }
        public ActionResult ACDataSource([FromBody]DataManagerRequest dm)
        {
            var val = orddata;
            var Data = val.ToList();
            var count = val.Count();
            if (dm.Where != null)
            {
                Data = (from cust in Data
                        where cust.ShipCountry.ToLower().StartsWith(dm.Where[0].value.ToString())
                        select cust).ToList();
            }
            if (dm.Take != 0)
                Data = Data.Take(dm.Take).ToList();
            return Json(Data);
        }
        public class Rule
        {
            public string Condition { get; set; }
            public string Label { get; set; }
            public string Field { get; set; }
            public string Operator { get; set; }
            public string Type { get; set; }
            public string Value { get; set; }
            public List<Rule> Rules { get; set; }
        }
        public class Data
        {
            public int take { get; set; }
            public List<Wheres> where { get; set; }
        }

        public class Wheres
        {
            public string field { get; set; }
            public bool ignoreAccent { get; set; }

            public bool ignoreCase { get; set; }

            public bool isComplex { get; set; }

            public string value { get; set; }
            public string Operator { get; set; }

        }
        public IActionResult BatchUpdate([FromBody]CRUDModel batchmodel)
        {
            if (batchmodel.Changed != null)
            {
                for (var i = 0; i < batchmodel.Changed.Count(); i++)
                {
                    var ord = batchmodel.Changed[i];
                    OrdersDetails val = orddata.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
                    val.OrderID = ord.OrderID;
                    val.EmployeeID = ord.EmployeeID;
                    val.CustomerID = ord.CustomerID;
                    val.ShipCity = ord.ShipCity;
                }
            }

            if (batchmodel.Deleted != null)
            {
                for (var i = 0; i < batchmodel.Deleted.Count(); i++)
                {
                    orddata.Remove(orddata.Where(or => or.OrderID == batchmodel.Deleted[i].OrderID).FirstOrDefault());
                }
            }

            if (batchmodel.Added != null)
            {
                for (var i = 0; i < batchmodel.Added.Count(); i++)
                {
                    orddata.Insert(0, batchmodel.Added[i]);
                }
            }
            var data = orddata.ToList();
            return Json(data);

        }

        public string AfterSave()
        {
            return "saved";

        }
        public class CRUDModel
        {
            public List<OrdersDetails> Added { get; set; }
            public List<OrdersDetails> Changed { get; set; }
            public List<OrdersDetails> Deleted { get; set; }
            public OrdersDetails Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }
        public void BindData()
        {
            int code = 10000;
            for (int i = 1; i < 6; i++)
            {
                orddata.Add(new OrdersDetails(code + 2, "ANATR", i + 0, 3 * i, true, new DateTime(1995, 7, 2, 2, 3, 5), "Madrid", "Queen Cozinha", "Brazil", new DateTime(1996, 9, 11), "Avda. Azteca 123"));
                orddata.Add(new OrdersDetails(code + 3, "ANTON", i + 1, 4 * i, true, new DateTime(2012, 12, 25, 2, 3, 5), "Cholchester", "Frankenversand", "Germany", new DateTime(1996, 10, 7), "Carrera 52 con Ave. Bolívar #65-98 Llano Largo"));
                orddata.Add(new OrdersDetails(code + 4, "BLONP", i + 2, 5 * i, false, new DateTime(2002, 12, 25, 2, 3, 5), "Marseille", "Ernst Handel", "Austria", new DateTime(1996, 12, 30), "Magazinweg 7"));
                orddata.Add(new OrdersDetails(code + 5, "BOLID", i + 3, 6 * i, true, new DateTime(1953, 02, 18, 05, 2, 4), "Tsawassen", "Hanari Carnes", "Switzerland", new DateTime(1997, 12, 3), "1029 - 12th Ave. S."));
            }
        }
        public void BindEpmployeeDataSource()
        {
            Employee.Add(new Employees( 1, "VINETReims"));
            Employee.Add(new Employees( 2, "ALFKIMünster"));
            Employee.Add(new Employees( 3, "TOMSPRio"));
            Employee.Add(new Employees( 4, "HANARLyon"));
            Employee.Add(new Employees( 5, "HILAAResende"));
            Employee.Add(new Employees( 2, "CENTCGraz"));
            Employee.Add(new Employees( 3, "RICSUMéxico"));
            Employee.Add(new Employees( 5, "ERNSHOulu"));
            Employee.Add(new Employees( 6, "RATTCLander"));
            Employee.Add(new Employees( 1, "BLONPBergamo"));
            Employee.Add(new Employees( 7, "QUICKMadrid"));
            Employee.Add(new Employees( 3, "LEHMSFrankfurt"));
            Employee.Add(new Employees( 1, "ROMEYReggio"));
            Employee.Add(new Employees( 2, "REGGCAlbuquerque"));
            Employee.Add(new Employees( 5, "BSBEVStrasbourg"));
        }
        public class OrdersDetails
        {
            public OrdersDetails()
            {

            }
            public OrdersDetails(int OrderID, string CustomerId, int EmployeeId, float Freight, bool Verified, DateTime OrderDate, string ShipCity, string ShipName, string ShipCountry, DateTime ShippedDate, string ShipAddress)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.ShipCity = ShipCity;
                this.Verified = Verified;
                this.OrderDate = OrderDate;
                this.ShipName = ShipName;
                this.ShipCountry = ShipCountry;
                this.ShippedDate = ShippedDate;
                this.ShipAddress = ShipAddress;
            }

            public int? OrderID { get; set; }
            public string CustomerID { get; set; }
            public int? EmployeeID { get; set; }
            public float? Freight { get; set; }
            public string ShipCity { get; set; }
            public bool Verified { get; set; }
            public DateTime OrderDate { get; set; }

            public string ShipName { get; set; }

            public string ShipCountry { get; set; }

            public DateTime ShippedDate { get; set; }
            public string ShipAddress { get; set; }
        }
        public class Employees
    {
        public Employees()
        {

        }
        public Employees( int EmployeeID, string FirstName)
        {
            this.EmployeeID = EmployeeID;
            this.FirstName = FirstName;
        }
        public int EmployeeID { get; set; }
        public string FirstName { get; set; }
    }
}
public class BaseTypes
{
    public BaseTypes()
    {

    }

    public BaseTypes(int baseId, string name, int typeId, double limit, double advRatio)
    {
        this.BaseID = baseId;
        this.Name = name;
        this.TypeID = typeId;
        this.Limit = limit;
        this.AdvRation = advRatio;

    }

    public int BaseID { get; set; }
    public string Name { get; set; }
    public int TypeID { get; set; }
    public double Limit { get; set; }
    public double AdvRation { get; set; }

    public static List<BaseTypes> GetAllBaseTypes()
    {
        List<BaseTypes> baseTypes = new List<BaseTypes>();

        baseTypes.Add(new BaseTypes(1, "Test1", 3, 125456.23, 100));
        baseTypes.Add(new BaseTypes(2, "Test2", 5, 524632.23, 100));

        return baseTypes;

    }



}

    public class PurTypes
    {
        PurTypes()
        {

        }

        public PurTypes(int typeId, string defType)
        {
            this.purTypeID = typeId;
            this.purType = defType;
        }
        public int purTypeID { get; set; }
        public string purType { get; set; }

        public static List<PurTypes> GetAllPurTypes()
        {
            List<PurTypes> purTypes = new List<PurTypes>();

            purTypes.Add(new PurTypes(1, "Type 1"));
            purTypes.Add(new PurTypes(2, "Type 2"));
            purTypes.Add(new PurTypes(3, "Type 3"));
            purTypes.Add(new PurTypes(4, "Type 4"));
            purTypes.Add(new PurTypes(5, "Type 5"));
            purTypes.Add(new PurTypes(6, "Type 6"));
            purTypes.Add(new PurTypes(7, "Type 7"));
            purTypes.Add(new PurTypes(8, "Type 8"));

            return purTypes;

        }
    }
}

